/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO (Extended = ExtendedPersistenceContext ConversationScope (Group = EntityExtendedDAO.class)
 *
 */

package de.ivu.elect.business.datei.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.datei.entity.DateiImport;
import de.ivu.elect.jee.entity.ExtendedDAO;

@javax.enterprise.context.RequestScoped
public class DateiImportExtendedDAO extends AbstractDateiImportDAO implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  @Inject
  transient ExtendedDAO extendedDAO;

  @Inject
  transient de.ivu.elect.presentation.system.ExtendedDAORequestCache cache;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return extendedDAO.getEntityManager();
  }

  @Override
  public void flush() {
    extendedDAO.flush();
  }

  public void flushNewTransaction() {
    extendedDAO.flushNewTransaction();
  }

/**
* Name: DateiImportArtAndWahlOrderBeiErstellungszeitpunktDescNoFlush<br>
* Beschreibung: Wird für die Suche beim Import von Dateien genutzt.<br>
* EJBQL: SELECT OBJECT(o) FROM DateiImport o WHERE o.dateiArt=?1 AND o.datei.wahl = ?2 ORDER BY o.datei.erstellungszeitpunkt DESC<br>
* SQL: <br>
*/
@Override
public java.util.List<DateiImport> findByDateiImportArtAndWahlOrderBeiErstellungszeitpunktDesc( @javax.annotation.Nonnull de.ivu.elect.business.exchange.entity.DateiImportArt dateiArt,  @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("DateiImport.findByDateiImportArtAndWahlOrderBeiErstellungszeitpunktDesc" ,  dateiArt ,  wahl  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByDateiImportArtAndWahlOrderBeiErstellungszeitpunktDesc(): Miss");
        }

        cache.put(key, super.findByDateiImportArtAndWahlOrderBeiErstellungszeitpunktDesc( dateiArt ,  wahl  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByDateiImportArtAndWahlOrderBeiErstellungszeitpunktDesc(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<DateiImport>) cache.lookup(key));
    }

    return super.findByDateiImportArtAndWahlOrderBeiErstellungszeitpunktDesc( dateiArt ,  wahl  );
}
/**
* Name: DateiImportArtOrderBeiErstellungszeitpunktDescNoFlush<br>
* Beschreibung: Wird für die Suche beim Import von Dateien genutzt.<br>
* EJBQL: SELECT OBJECT(o) FROM DateiImport o WHERE o.datei.mandant=?1 AND o.dateiArt=?2 ORDER BY o.datei.erstellungszeitpunkt DESC<br>
* SQL: <br>
*/
@Override
public java.util.List<DateiImport> findByDateiImportArtOrderBeiErstellungszeitpunktDesc( @javax.annotation.Nonnull de.ivu.elect.business.mandant.entity.Mandant mandant,  @javax.annotation.Nonnull de.ivu.elect.business.exchange.entity.DateiImportArt dateiArt) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("DateiImport.findByDateiImportArtOrderBeiErstellungszeitpunktDesc" ,  mandant ,  dateiArt  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByDateiImportArtOrderBeiErstellungszeitpunktDesc(): Miss");
        }

        cache.put(key, super.findByDateiImportArtOrderBeiErstellungszeitpunktDesc( mandant ,  dateiArt  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByDateiImportArtOrderBeiErstellungszeitpunktDesc(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<DateiImport>) cache.lookup(key));
    }

    return super.findByDateiImportArtOrderBeiErstellungszeitpunktDesc( mandant ,  dateiArt  );
}

  @Override
  public void clear() {
    cache.clear();

    super.clear();
  }
}
